*------------------------------------------------------------*
#include <hmg.ch>
*------------------------------------------------------------*
function main()

PRIVATE aRecs:={}

REQUEST DBFNSX
SET BROWSESYNC ON
SET DATE ITALIAN

dbUseArea(.T.,"DBFNSX","MUSIC",.F.)
OrdSetFocus(1)
dbGoTop()

DEFINE WINDOW wndMain;
   AT 90,90;
   WIDTH 675;
   HEIGHT 403;
   TITLE "Selection of records Demo";
   ON RELEASE DBCloseAll();
   MAIN

DEFINE MAIN MENU
   DEFINE POPUP 'Demo'
      MENUITEM 'Select\unselect the current record' ACTION (SelectRecord(@aRecs,wndMain.brsDemo.Value),wndMain.brsDemo.Refresh())
      MENUITEM 'Show number of selected records' ACTION MsgDebug(alltrim(str(len(aRecs))) + ' records selected')
      MENUITEM 'Show record numbers of selected records' ACTION MsgDebug(aRecs)
      MENUITEM 'Unselect all records'  ACTION (aRecs:={},wndMain.brsDemo.Refresh())

   END POPUP
END MENU

DEFINE STATUSBAR
STATUSITEM "Double click the checkbox or use CTRL-F12 to select\unselect the current record"
STATUSITEM " " WIDTH 15
END STATUSBAR

END WINDOW

@ 5,5 BROWSE brsDemo;
   OF wndMain;
   WIDTH 645;
   HEIGHT 315;
   HEADERS {"M","Nummer","Trk","Artiest","Titel"} ;
   WIDTHS {23, 65,35,248,249};
   IMAGE { "bmpUnChecked","bmpChecked" } ;
   WORKAREA MUSIC;
   FIELDS {"iif(ASCAN(aRecs,Recno())<>0,'.T.','F')","MUSIC->NR","MUSIC->DTR","MUSIC->ARTIEST","MUSIC->TITEL"};
   JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT} ;
   ON DBLCLICK DblClickBrowseScreen()

ON KEY CONTROL+F12 OF wndMain          ACTION (SelectRecord(@aRecs,wndMain.brsDemo.Value),_PushKey(VK_DOWN),wndMain.brsDemo.Refresh())

wndMain.Center
wndMain.Activate

return NIL
*------------------------------------------------------------*
STATIC FUNCTION DblClickBrowseScreen

IF This.CellColIndex == 1
   SelectRecord(@aRecs,This.Value)
   This.Refresh()
ELSE
   MsgDebug("Record number " + alltrim(str(This.Value)) + " double clicked")
ENDIF

RETURN(NIL)
*------------------------------------------------------------*
Function SelectRecord(aRecs,nRecord)

LOCAL nKey

DEFAULT nRecord:=RecNo()

nKey:=ascan( aRecs, nRecord )

IF nKey==0
   nKey:=ascan(aRecs,nil)
   IF nKey==0
      aadd( aRecs,nRecord)
   ELSE
      aRecs[nKey]:=nRecord
   ENDIF
ELSE
   ADEL(aRecs,nKey)
   ASIZE(aRecs,LEN(aRecs)-1)
ENDIF

RETURN(NIL)
*------------------------------------------------------------*